/**
 * User space driver API for FocalTech's fingerprint device.
 * ATTENTION: Do NOT edit this file unless the corresponding driver changed.
 *
 * Copyright (C) 2016-2017 FocalTech Systems Co., Ltd. All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
 * Public License for more details.
**/

#ifndef __FF_CTRL_API_H__
#define __FF_CTRL_API_H__

#include <linux/ioctl.h>

/* Device node. */
#define FF_CTL_DEV_NAME "/dev/focaltech_fp"

/* Max driver version buffer length. */
#define FF_DRV_VERSION_LEN 32

/* Max hal version buffer length. */
#define FF_HAL_VERSION_LEN 64
typedef struct {
    unsigned int code;
    int value;
} ff_key_event_t;

typedef struct {
    /* Using asynchronous notification mechanism instead of NETLINK. */
    bool enable_fasync;

    /* Gesture(Key emulation & Navigation) key codes. */
    int32_t keycode_nav_left;
    int32_t keycode_nav_right;
    int32_t keycode_nav_up;
    int32_t keycode_nav_down;
    int32_t keycode_double_click;
    int32_t keycode_click;
    int32_t keycode_long_press;
    int32_t keycode_simulation;

    /* For '/dev/spidevB.C' of REE-Emulation. */
    bool enable_spidev;
    int32_t spidev_bus;
    int32_t spidev_c_s;

    /* For obsolete driver that doesn't support device tree. */
    int32_t gpio_mosi_pin;
    int32_t gpio_miso_pin;
    int32_t gpio_ck_pin;
    int32_t gpio_cs_pin;
    int32_t gpio_rst_pin;
    int32_t gpio_int_pin;
    int32_t gpio_power_pin;
    int32_t gpio_iovcc_pin;

    /* Logging driver to logcat through uevent mechanism. */
    int32_t log_level;
    bool logcat_driver;
} ff_driver_config_t;


typedef enum {
    FF_POLLEVT_NONE = 0,
    FF_POLLEVT_INTERRUPT = (1 << 0),
    FF_POLLEVT_SCREEN_ON = (1 << 1),
    FF_POLLEVT_SCREEN_OFF = (1 << 2),
} ff_poll_event_t;

typedef enum {
    FF_EVENT_NONE = 0,
    FF_EVENT_FASYNC = 1,
    FF_EVENT_NETLINK = 2,
    FF_EVENT_POLL = 3,
} ff_event_t;

typedef struct {
    uint16_t ver;
    uint16_t reserved1;
    uint32_t fbs_power_const      : 1;
    uint32_t fbs_wakelock         : 1;
    uint32_t fbs_screen_onoff     : 1;
    uint32_t fbs_pollevt          : 1;
    uint32_t fbs_reset_hl         : 1;
    uint32_t fbs_spiclk           : 1;
    uint32_t fbs_unused           : 26;
    uint32_t reserved2[32];
} ff_feature_t;

/* Magic code for IOCTL-subsystem, 'f'(0x66) means '[F]ocalTech'. */
#define FF_IOC_MAGIC 'f'

/* Allocate/Release driver resource (GPIO/SPI etc.). */
#define FF_IOC_INIT_DRIVER      _IO(FF_IOC_MAGIC, 0x00)
#define FF_IOC_FREE_DRIVER      _IO(FF_IOC_MAGIC, 0x01)

/* HW reset the fingerprint module. */
#define FF_IOC_RESET_DEVICE     _IO(FF_IOC_MAGIC, 0x02)
#define FF_IOC_RESET_DEVICE_HL  _IOW(FF_IOC_MAGIC, 0x02, uint32_t)

/* Low-level IRQ control. */
#define FF_IOC_ENABLE_IRQ       _IO(FF_IOC_MAGIC, 0x03)
#define FF_IOC_DISABLE_IRQ      _IO(FF_IOC_MAGIC, 0x04)

/* SPI bus clock control, for power-saving purpose. */
#define FF_IOC_ENABLE_SPI_CLK   _IO(FF_IOC_MAGIC, 0x05)
#define FF_IOC_DISABLE_SPI_CLK  _IO(FF_IOC_MAGIC, 0x06)

/* Fingerprint module power control. */
#define FF_IOC_ENABLE_POWER     _IO(FF_IOC_MAGIC, 0x07)
#define FF_IOC_DISABLE_POWER    _IO(FF_IOC_MAGIC, 0x08)

/* Androind system-wide key event, for navigation purpose. */
#define FF_IOC_REPORT_KEY_EVENT _IOW(FF_IOC_MAGIC, 0x09, ff_key_event_t)

/* Sync 'ff_driver_config_t', the driver configuration. */
#define FF_IOC_SYNC_CONFIG     _IOWR(FF_IOC_MAGIC, 0x0a, ff_driver_config_t)

/* Query the driver version string. */
#define FF_IOC_GET_VERSION      _IOR(FF_IOC_MAGIC, 0x0b, const char)


/* Set vendor driver info. */
#define FF_IOC_SET_VENDOR_INFO  _IOW(FF_IOC_MAGIC, 0x0c, const char)

/* Acquire the WakeLock for a while. */
#define FF_IOC_WAKELOCK_ACQUIRE _IOW(FF_IOC_MAGIC, 0x0d, uint32_t)

/* Release the WakeLock immediately. */
#define FF_IOC_WAKELOCK_RELEASE _IO(FF_IOC_MAGIC, 0x0e)

/* device unprobe*/
#define FF_IOC_UNPROBE          _IO(FF_IOC_MAGIC, 0x0F)

/* set log level */
#define FF_IOC_SET_LOGLEVEL     _IOW(FF_IOC_MAGIC, 0x10, int)
#define FF_IOC_GET_LOGLEVEL     _IOR(FF_IOC_MAGIC, 0x10, int)

/*get feature*/
#define FF_IOC_GET_FEATURE      _IOR(FF_IOC_MAGIC, 0x11, ff_feature_t)

/* set event type */
#define FF_IOC_SET_EVENT_TYPE   _IOW(FF_IOC_MAGIC, 0x12, int)
#define FF_IOC_GET_EVENT_TYPE   _IOR(FF_IOC_MAGIC, 0x12, int)

/*get event info*/
#define FF_IOC_GET_EVENT_INFO   _IOR(FF_IOC_MAGIC, 0x13, int)
/* For ftm test */
#define FF_IOC_WRITE_HAL_VERSION      _IOW(FF_IOC_MAGIC, 0x0c, const char)
#define FF_IOC_WRITE_FINGER_STATE     _IOW(FF_IOC_MAGIC, 0x0d, int)
/* Query the driver version string. */
#define FF_IOC_GET_HAL_VERSION      _IOR(FF_IOC_MAGIC, 0x0e, const char)
#endif /* __FF_CTRL_API_H__ */
